"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_native_1 = require("react-native");
var Emitter_1 = require("../../modules/listener/Emitter");
var Screen_1 = require("../../modules/listener/Screen");
var PropTypes = require('prop-types');
var DrawerAndroid = (function (_super) {
    __extends(DrawerAndroid, _super);
    function DrawerAndroid() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            isOpen: false,
            width: 0
        };
        return _this;
    }
    DrawerAndroid.prototype.getChildContext = function () {
        return {
            drawer: {
                toggle: this.toggle.bind(this),
                close: this.close.bind(this),
                isOpen: this.isOpen.bind(this)
            }
        };
    };
    DrawerAndroid.prototype.componentDidMount = function () {
        this.onDimensionsChangeListener = Emitter_1.default.on('onDimensionsChange', this.onDimensionsChange.bind(this));
        this.onDimensionsChange();
    };
    DrawerAndroid.prototype.componentWillUnmount = function () {
        Emitter_1.default.off(this.onDimensionsChangeListener);
    };
    DrawerAndroid.prototype.onDimensionsChange = function () {
        this.setState({
            width: Screen_1.default.getDimensions().width
        });
    };
    DrawerAndroid.prototype.isOpen = function () {
        return this.state.isOpen;
    };
    DrawerAndroid.prototype.toggle = function () {
        if (this.state.isOpen) {
            this.close();
        }
        else {
            this.open();
        }
    };
    DrawerAndroid.prototype.close = function () {
        this.refs.drawer.closeDrawer();
    };
    DrawerAndroid.prototype.open = function () {
        this.refs.drawer.openDrawer();
    };
    DrawerAndroid.prototype.onDrawerClose = function () {
        this.setState({ isOpen: false });
        if (this.props.onCloseStart) {
            this.props.onCloseStart();
        }
    };
    DrawerAndroid.prototype.onDrawerOpen = function () {
        this.setState({ isOpen: true });
        if (this.props.onOpenStart) {
            this.props.onOpenStart();
        }
    };
    DrawerAndroid.prototype.render = function () {
        var width = this.state.width;
        if (width < 1) {
            return null;
        }
        var drawerWidth = width > 360 ? 360 : width;
        drawerWidth *= width < 250 ? 0.9 : 0.8;
        var _a = this.props, content = _a.content, children = _a.children, props = __rest(_a, ["content", "children"]);
        return (React.createElement(react_native_1.DrawerLayoutAndroid, { ref: 'drawer', drawerWidth: drawerWidth, onDrawerOpen: this.onDrawerOpen.bind(this), onDrawerClose: this.onDrawerClose.bind(this), drawerPosition: react_native_1.DrawerLayoutAndroid.positions.Left, renderNavigationView: function () { return content; } }, children));
    };
    return DrawerAndroid;
}(React.Component));
DrawerAndroid.childContextTypes = {
    drawer: PropTypes.object
};
exports.default = DrawerAndroid;
