/// <reference types="react" />
import * as React from 'react';
export interface DrawerProps {
    children?: JSX.Element;
    content: JSX.Element;
    tabletContent?: JSX.Element;
    useTabledMode?: boolean;
    tabledModeMinWidth?: number;
    onOpenStart?: () => void;
    onCloseStart?: () => void;
}
export interface State {
}
export default class Drawer extends React.Component<DrawerProps, State> {
    state: {
        isOpen: boolean;
        height: number;
        width: number;
    };
    refs: {
        [string: string]: any;
    };
    onDimensionsChangeListener: any;
    handler(ratio: number): {
        main: {
            style: {
                transformMatrix: number[];
            };
        };
        mainOverlay: {
            zIndex: number;
            opacity: number;
            cursor: string;
            backgroundColor: string;
        };
    };
    isOpen(): boolean;
    toggle(): void;
    close(): void;
    open(): void;
    componentDidMount(): void;
    componentWillUnmount(): void;
    onDimensionsChange(): void;
    render(): JSX.Element | null;
}
