"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var Log_1 = require("../../modules/logger/Log");
var React = require("react");
var react_native_drawer_1 = require("react-native-drawer");
var Emitter_1 = require("../../modules/listener/Emitter");
var Screen_1 = require("../../modules/listener/Screen");
var DrawerTablet_1 = require("./DrawerTablet");
var Drawer = (function (_super) {
    __extends(Drawer, _super);
    function Drawer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            isOpen: false,
            height: 0,
            width: 0
        };
        return _this;
    }
    Drawer.prototype.handler = function (ratio) {
        var r0 = -ratio / 6;
        var r1 = 1 - ratio / 6;
        var t = [r1, r0, 0, 0, -r0, r1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1];
        return {
            main: {
                style: {
                    transformMatrix: t
                    // opacity: 1 - ratio / 2
                }
            },
            mainOverlay: {
                zIndex: 9,
                opacity: ratio,
                cursor: 'pointer',
                backgroundColor: 'rgba(0,0,0,0.4)'
            }
        };
    };
    Drawer.prototype.isOpen = function () {
        return this.state.isOpen;
    };
    Drawer.prototype.toggle = function () {
        if (this.state.isOpen) {
            this.close();
        }
        else {
            this.open();
        }
    };
    Drawer.prototype.close = function () {
        this.refs.drawer && this.refs.drawer.close();
    };
    Drawer.prototype.open = function () {
        this.refs.drawer && this.refs.drawer.open();
    };
    Drawer.prototype.componentDidMount = function () {
        this.onDimensionsChangeListener = Emitter_1.default.on('onDimensionsChange', this.onDimensionsChange.bind(this));
        Screen_1.default.updateDimensions();
    };
    Drawer.prototype.componentWillUnmount = function () {
        Emitter_1.default.off(this.onDimensionsChangeListener);
    };
    Drawer.prototype.onDimensionsChange = function () {
        var _a = Screen_1.default.getDimensions(), width = _a.width, height = _a.height;
        this.setState({ width: width, height: height });
    };
    Drawer.prototype.render = function () {
        var _a = this.state, width = _a.width, height = _a.height;
        if (width < 1) {
            return null;
        }
        var _b = this.props, tabledModeMinWidth = _b.tabledModeMinWidth, tabletContent = _b.tabletContent, content = _b.content, useTabledMode = _b.useTabledMode, props = __rest(_b, ["tabledModeMinWidth", "tabletContent", "content", "useTabledMode"]);
        var styles = {
            drawer: {
                backgroundColor: '#fff',
                zIndex: 10,
                elevation: 8,
                shadowColor: 'rgba(0,0,0,0.8)',
                shadowOpacity: 0.3,
                shadowRadius: 4,
                shadowOffset: {
                    height: 2,
                    width: 3
                }
                //position: Platform.OS === 'web' ? 'fixed' : 'absolute',
                //position: 'absolute',
                //height
            },
            main: {
                // backgroundColor: 'red',
                paddingLeft: 30,
                zIndex: 8
                //width,
                //height
            }
        };
        if (width < 1) {
            return null;
        }
        var containerWidth = width || 300;
        var maxWidth = containerWidth > 360 ? 360 : containerWidth;
        maxWidth *= containerWidth < 250 ? 0.9 : 0.8;
        Log_1.default.info('maxWidth', maxWidth, containerWidth);
        var minWidthTabled = tabledModeMinWidth || 800;
        if (width > minWidthTabled && useTabledMode) {
            return (React.createElement(DrawerTablet_1.default, __assign({ leftStyle: { width: maxWidth }, content: tabletContent ? tabletContent : content }, this.props)));
        }
        return (React.createElement(react_native_drawer_1.default, __assign({ ref: 'drawer', type: 'overlay', tapToClose: true, openDrawerOffset: function (viewport) { return viewport.width - maxWidth; }, closedDrawerOffset: -30, styles: styles, content: content, tweenHandler: this.handler.bind(this) }, props)));
    };
    return Drawer;
}(React.Component));
exports.default = Drawer;
