"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ListView_1 = require("./ListView");
var View_1 = require("./View");
var Emitter_1 = require("../../modules/listener/Emitter");
var Screen_1 = require("../../modules/listener/Screen");
var react_native_1 = require("react-native");
var Log_1 = require("../../modules/logger/Log");
var FlexibleGrid = (function (_super) {
    __extends(FlexibleGrid, _super);
    function FlexibleGrid() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            itemWidth: 0,
            containerWidth: 0,
            containerHeight: 0
        };
        return _this;
    }
    FlexibleGrid.prototype.onDimensionsChange = function () {
        var _this = this;
        var width = Screen_1.default.getDimensions().width;
        var _a = this.props, itemWidth = _a.itemWidth, itemMargin = _a.itemMargin;
        var contentWidth = width;
        if (this.state.containerWidth) {
            contentWidth = this.state.containerWidth;
        }
        var cols = Math.floor(contentWidth / itemWidth);
        cols = cols < 1 ? 1 : cols;
        itemMargin = itemMargin || 0;
        var windowWidth = contentWidth - itemMargin * ((cols + 1) * 2) - 1;
        itemWidth = windowWidth / cols;
        this.setState({ itemWidth: itemWidth }, function () {
            _this.refs.list && _this.refs.list.refreshView();
        });
        Log_1.default.info(contentWidth, itemWidth, itemMargin);
    };
    FlexibleGrid.prototype.componentDidMount = function () {
        this.onDimensionsChangeListener = Emitter_1.default.on('onDimensionsChange', this.onDimensionsChange.bind(this));
        this.onDimensionsChange();
    };
    FlexibleGrid.prototype.componentWillUnmount = function () {
        Emitter_1.default.off(this.onDimensionsChangeListener);
    };
    FlexibleGrid.prototype.renderRow = function (rowData, sectionID, rowID, highlightRow) {
        var margin = this.props.itemMargin || 0;
        var width = 0;
        var itemWidth = this.state.itemWidth;
        if (itemWidth > 0) {
            width = itemWidth;
        }
        var customStyle = { margin: margin, width: width };
        return (React.createElement(View_1.default, { style: customStyle }, this.props.renderRow(rowData, sectionID, rowID, highlightRow, customStyle)));
    };
    FlexibleGrid.prototype.refreshView = function () {
        this.refs.list && this.refs.list.refreshView();
    };
    FlexibleGrid.prototype.onLayout = function (event) {
        this.setState({
            containerWidth: event.nativeEvent.layout.width,
            containerHeight: event.nativeEvent.layout.height
        });
        if (this.props.onLayout) {
            this.props.onLayout(event);
        }
    };
    FlexibleGrid.prototype.render = function () {
        var _a = this.props, renderRow = _a.renderRow, itemWidth = _a.itemWidth, itemMargin = _a.itemMargin, style = _a.style, props = __rest(_a, ["renderRow", "itemWidth", "itemMargin", "style"]);
        return (React.createElement(ListView_1.default, __assign({}, props, { ref: 'list', style: style, contentContainerStyle: [
                styles.list,
                { padding: this.props.itemMargin }
            ], onLayout: this.onLayout.bind(this), renderRow: this.renderRow.bind(this) })));
    };
    return FlexibleGrid;
}(React.Component));
exports.default = FlexibleGrid;
var styles = react_native_1.StyleSheet.create({
    list: {
        flexDirection: 'row',
        flexWrap: 'wrap',
        alignItems: 'flex-start'
    }
});
