"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_native_1 = require("react-native");
var Text_1 = require("./Text");
var View_1 = require("./View");
var Input = (function (_super) {
    __extends(Input, _super);
    function Input() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: ''
        };
        return _this;
    }
    Input.prototype.setValue = function (value) {
        this.setState({ value: value });
    };
    Input.prototype.getValue = function () {
        return this.state.value;
    };
    Input.prototype.focus = function () {
        this.refs.input.focus();
    };
    Input.prototype.onChangeText = function (text) {
        this.setValue(text);
        if (typeof this.props.onChangeText === 'function') {
            this.props.onChangeText(text);
        }
    };
    Input.prototype.componentDidMount = function () {
        if (this.props.defaultValue) {
            this.setValue(this.props.defaultValue);
        }
    };
    Input.prototype.render = function () {
        var _a = this.props, value = _a.value, defaultValue = _a.defaultValue, containerStyle = _a.containerStyle, style = _a.style, useLabel = _a.useLabel, placeholder = _a.placeholder, props = __rest(_a, ["value", "defaultValue", "containerStyle", "style", "useLabel", "placeholder"]);
        var newProps = __assign({}, props);
        newProps.value = this.state.value;
        newProps.onChangeText = this.onChangeText.bind(this);
        if (!useLabel) {
            newProps.placeholder = placeholder;
        }
        return (React.createElement(View_1.default, { style: [styles.container] },
            useLabel && React.createElement(Text_1.default, { style: styles.label }, placeholder),
            React.createElement(View_1.default, { style: [styles.inputContainer, containerStyle] },
                React.createElement(react_native_1.TextInput, __assign({ underlineColorAndroid: 'transparent', placeholderTextColor: '#444', style: [styles.input, style], ref: 'input' }, newProps)))));
    };
    return Input;
}(React.Component));
exports.default = Input;
var styles = react_native_1.StyleSheet.create({
    container: {
        paddingTop: 4,
        paddingBottom: 10
    },
    label: {
        color: '#999',
        textAlign: 'center',
        padding: 4
    },
    inputContainer: {
        borderColor: '#f4f4f4',
        backgroundColor: '#f4f4f4',
        borderRadius: 4,
        borderWidth: 1,
        padding: 1
    },
    input: {
        height: 35,
        backgroundColor: '#f9f9f9',
        color: '#444',
        borderRadius: 4,
        fontSize: 13,
        padding: 4,
        paddingLeft: 10,
        paddingRight: 10
    }
});
