/// <reference types="react" />
import * as React from 'react';
import { Animated, LayoutChangeEvent } from 'react-native';
import EndCallback = Animated.EndCallback;
export interface Message {
    id?: string;
    title?: string;
    message?: string;
    isLoading?: boolean;
    autoDismiss?: number;
}
export interface MessageItemProps {
    item: Message;
    level?: 'info' | 'default' | 'alert' | 'warning';
    onHide: () => void;
}
export interface State {
    top: Animated.Value;
    fade: Animated.Value;
    itemHeight: number;
}
export default class MessageItem extends React.Component<MessageItemProps, State> {
    state: {
        top: Animated.Value;
        fade: Animated.Value;
        itemHeight: number;
    };
    private animation;
    private timeoutDismiss;
    onLayout(event: LayoutChangeEvent): void;
    show(): void;
    hide(cb: EndCallback): void;
    componentDidMount(): void;
    componentWillUnmount(): void;
    autoDismissSetup(): void;
    componentDidUpdate(prevProps: MessageItemProps, prevState: State): void;
    render(): JSX.Element;
}
