"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_native_1 = require("react-native");
var Button_1 = require("./Button");
var Panel = (function (_super) {
    __extends(Panel, _super);
    function Panel() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Panel.prototype.render = function () {
        var _a = this.props, title = _a.title, style = _a.style, children = _a.children, actions = _a.actions, toolbarHeight = _a.toolbarHeight;
        var height = toolbarHeight || 50;
        var extra = react_native_1.Platform.OS === 'android' && react_native_1.Platform.Version < 21 ? 1 : 0;
        var top = (height + extra) * -1;
        return (React.createElement(react_native_1.View, { style: [styles.container, { marginTop: height }, style] },
            React.createElement(react_native_1.View, null, children),
            typeof title === 'object' &&
                React.createElement(react_native_1.View, { style: [styles.toolbar, { height: height, top: top }] }, title),
            typeof title !== 'object' &&
                React.createElement(react_native_1.View, { style: [styles.toolbar, { height: height, top: top }] },
                    React.createElement(react_native_1.Text, { style: [styles.title] }, title)),
            actions &&
                actions.length > 0 &&
                React.createElement(react_native_1.View, { style: styles.options }, actions.map(function (item, index) {
                    return React.createElement(Button_1.default, __assign({ key: index }, item));
                }))));
    };
    return Panel;
}(React.Component));
exports.default = Panel;
var styles = react_native_1.StyleSheet.create({
    container: {
        position: 'relative'
    },
    toolbar: {
        position: 'absolute',
        left: 0,
        right: 0,
        top: 0,
        paddingLeft: 10,
        paddingRight: 10,
        paddingTop: 5,
        paddingBottom: 5,
        flex: 1,
        flexDirection: 'row',
        backgroundColor: '#f9f9f9',
        alignItems: 'center'
    },
    options: {
        flexDirection: 'row'
    },
    title: {
        fontSize: 15,
        flex: 1,
        color: '#444444'
    }
});
