export interface UserSettings {
    themes: Themes;
    defaultTheme?: string;
}
export interface Settings {
    themes: Themes;
    defaultTheme: string;
}
export declare type ThemeVar = string | number;
export interface SingleTheme {
    [key: string]: ThemeVar;
}
export interface Vars {
    [key: string]: ThemeVar;
}
export interface Themes {
    [key: string]: SingleTheme;
}
export default class Theme {
    static settings: Settings;
    static theme: string;
    static vars: Vars;
    static init(settings: UserSettings): Promise<void>;
    static setTheme(theme: string): void;
    static getTheme(): string;
    static getUserTheme(): Promise<string>;
    static getDefaultTheme(): string;
}
